/*      
 *       $$
 *
 *     Copyright (C) 1999 - 2001, Daniel Potts, University of New South Wales.
 *
 *     Copyright (C) 1995, 1996, Sebastian Schoenberg, University of 
 *     Technology Dresden, Department of Computer Science.
 *
 *     This file is part of the L4/Alpha micro-kernel distribution.
 *
 *     This program is free software; you can redistribute it and/or
 *     modify it under the terms of the GNU General Public License
 *     as published by the Free Software Foundation; either version 2
 *     of the License, or (at your option) any later version.
 *     
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *     
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *     
 */
/* 
 * Proportions of this file are taken from L4/MIPS dit.h. L4 on Alpha
 * attempts to make use of the same structures to make programming
 * easier.  
 */

#ifndef DITE_H
#define DITE_H

#define DITE_RUN         0x01
#define DITE_MANAGER     0x02

#define DITE_NIDENT      4
#define DITE_NPNAME      16

typedef unsigned int Dite_uint;

struct Dite_Dhdr {
  char d_ident[DITE_NIDENT];
  Dite_uint d_phoff;
  Dite_uint d_phsize;
  Dite_uint d_phnum;
  Dite_uint d_fileend;
  Dite_uint d_vaddrend;
};             /* DITE Header */

struct Dite_Phdr {
  Dite_uint p_base;
  Dite_uint p_size;
  Dite_uint p_entry;
  Dite_uint p_flags;
  char p_name[DITE_NPNAME];
};             /* DITE File entry */

struct Dite_Phdr * dite_getentry(struct Dite_Dhdr * dite_hdr, int pos);
struct Dite_Dhdr * dite_gethdr(void);

#endif
