#ifndef _IO_H_
#define _IO_H_

#include <assert.h>

static inline uint8_t 
io_read_8( bus_space_t handle, uintptr_t offset)
{
   volatile uint8_t *c;
   c = handle + offset;
   return *c;
}

static inline void 
io_write_8( bus_space_t handle, uintptr_t offset, uint8_t value )
{
   volatile uint8_t *c;
   c = handle + offset;
   *c = value;
}

static inline void 
io_write_16( bus_space_t handle, uintptr_t offset, 
					  uint16_t value )
{
	assert( !"asw_16 NYI" );
}

static inline uint32_t 
io_read_32( bus_space_t handle, uintptr_t offset )
{
	volatile uint32_t *p = handle + offset;
	uint32_t i = *p;

	return i;
}

static inline void 
io_write_32( bus_space_t handle, uintptr_t offset, uint32_t value )
{
	volatile uint32_t *p = handle + offset;
	*p = value;
}


#endif
