/****************************************************************************
 *
 *      $Id: $
 *
 *      Description: Dite handling code for the L4 Environment library
 *
 *      Author:      Ben Leslie
 *
 ****************************************************************************/

#include <types.h>
#include <dite.h>
#include <stddef.h>
#include <l4.h>
#include <l4e.h>
#include <string.h>

extern void _start(void);

/* Check for magic at that address */
struct Dite_Dhdr *
dite_gethdr(void)
{
        struct Dite_Dhdr *dit_hdr;
	void *addr;

        addr = _start;

        /* find the dit header 1 page *before* the start */
	/* This is magic */
        addr -= PAGESIZE;

	dit_hdr = addr;

        /* Check to see if DIT is really here */
	if (strncmp(dit_hdr->d_ident, "dhdr", 4) == 0)
                return dit_hdr;
        else
                return NULL;
}

struct Dite_Phdr *
dite_getentry(struct Dite_Dhdr * dite_hdr, int pos)
{
	return (struct Dite_Phdr*) (((char*)dite_hdr + dite_hdr->d_phoff) + 
				    (pos * dite_hdr->d_phsize));
}
