/****************************************************************************
 *
 *      $Id: hardware.c,v 1.1 2003/08/06 22:52:04 benjl Exp $
 *
 *      Description: Device driver and TCP/IP initialisation for SOS
 *
 *      Author:      Ben Leslie
 *
 ****************************************************************************/

#include <dev.h>
#include <serial.h>
#include <stddef.h>

#include "hardware.h"

struct serial *serial;

/*
  Should be called at startup to initialise the U4600 hardware
*/
void
hardware_init(void)
{
	bus_space_t space[2];
	bs_seq sserial;

	/* Ensure the serial device memory is mapped in */
	map_physical(NULL, (void*) 0x1c800000, 0x1000);

	/* Initialise the serial driver */
	sserial.c = 2;
	sserial.v = space;
	sserial.v[0] = (void*)     0x1c800030;
	sserial.v[1] = (void*)     0x1c800031;

	/* Initialise the serial driver */
	serial = serial_init(sserial);

	/* Register an interrupt handler for the serial driver */
	register_cpu_interrupt_handler(NULL, 4, serial_interrupt_handler, 
				       serial);
}
